#!/usr/bin/env bash
-# set locale to UTF-8 compatible. apologies to non-english speakers...
-locale-gen en_GB.utf8
-update-locale LANG=en_GB.utf8 LC_ALL=en_GB.utf8
-export LANG=en_GB.utf8
-export LC_ALL=en_GB.utf8
+# abort on error
+set -e
# make sure we have up-to-date packages
apt-get update
apt-get upgrade -y
# install packages as explained in INSTALL.md
-apt-get install -y ruby2.0 libruby2.0 ruby2.0-dev \
- libmagickwand-dev libxml2-dev libxslt1-dev nodejs \
- apache2 apache2-threaded-dev build-essential git-core \
- postgresql postgresql-contrib libpq-dev postgresql-server-dev-all \
- libsasl2-dev imagemagick
-gem2.0 install bundler
+apt-get install -y ruby ruby-dev ruby-bundler \
+ libxml2-dev libxslt1-dev nodejs npm \
+ build-essential git-core firefox-esr \
+ postgresql postgresql-contrib libpq-dev libvips-dev libyaml-dev \
+ libsasl2-dev libffi-dev libgd-dev libarchive-dev libbz2-dev
+npm install --global yarn
## install the bundle necessary for openstreetmap-website
pushd /srv/openstreetmap-website
# do bundle install as a convenience
-sudo -u vagrant -H bundle install
+bundle install --retry=10 --jobs=2
+# do yarn install as a convenience
+bundle exec bin/yarn install
# create user and database for openstreetmap-website
db_user_exists=`sudo -u postgres psql postgres -tAc "select 1 from pg_roles where rolname='vagrant'"`
if [ "$db_user_exists" != "1" ]; then
- sudo -u postgres createuser -s vagrant
- sudo -u vagrant -H createdb -E UTF-8 -O vagrant openstreetmap
- sudo -u vagrant -H createdb -E UTF-8 -O vagrant osm_test
- # add btree_gist extension
- sudo -u vagrant -H psql -c "create extension btree_gist" openstreetmap
- sudo -u vagrant -H psql -c "create extension btree_gist" osm_test
+ sudo -u postgres createuser -s vagrant
fi
-# build and set up postgres extensions
-pushd db/functions
-sudo -u vagrant make
-sudo -u vagrant psql openstreetmap -c "CREATE OR REPLACE FUNCTION maptile_for_point(int8, int8, int4) RETURNS int4 AS '/srv/openstreetmap-website/db/functions/libpgosm.so', 'maptile_for_point' LANGUAGE C STRICT"
-sudo -u vagrant psql openstreetmap -c "CREATE OR REPLACE FUNCTION tile_for_point(int4, int4) RETURNS int8 AS '/srv/openstreetmap-website/db/functions/libpgosm.so', 'tile_for_point' LANGUAGE C STRICT"
-sudo -u vagrant psql openstreetmap -c "CREATE OR REPLACE FUNCTION xid_to_int4(xid) RETURNS int4 AS '/srv/openstreetmap-website/db/functions/libpgosm.so', 'xid_to_int4' LANGUAGE C STRICT"
-popd
+
# set up sample configs
if [ ! -f config/database.yml ]; then
- sudo -u vagrant cp config/example.database.yml config/database.yml
+ sudo -u vagrant cp config/example.database.yml config/database.yml
fi
-if [ ! -f config/application.yml ]; then
- sudo -u vagrant cp config/example.application.yml config/application.yml
+if [ ! -f config/storage.yml ]; then
+ cp config/example.storage.yml config/storage.yml
fi
+touch config/settings.local.yml
+# create the databases
+sudo -u vagrant bundle exec rails db:create
# migrate the database to the latest version
-sudo -u vagrant rake db:migrate
+sudo -u vagrant bundle exec rails db:migrate
popd